/*
 * Copyright 2019, 2023 NXP
 * All rights reserved.
 *
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include <stdio.h>
#include "header.h"

/*******************************************************************************
 * Definitions
 ******************************************************************************/
static MECC_Type my_mecc;

/*******************************************************************************
 * Prototypes
 ******************************************************************************/


/*******************************************************************************
 * Variables
 ******************************************************************************/

/*******************************************************************************
 * Code
 ******************************************************************************/
mecc_single_error_info_t singleErrorInfo;

void test_gcc_optimization(void)
{
    *(volatile uint32_t *)((&my_mecc)->SINGLE_ERR_ADDR_ECC0   ) = 0x000020C9;
    *(volatile uint32_t *)((&my_mecc)->SINGLE_ERR_DATA_LOW0   ) = 0x44332215;
    *(volatile uint32_t *)((&my_mecc)->SINGLE_ERR_DATA_HIGH0  ) = 0x11223344;
    *(volatile uint32_t *)((&my_mecc)->SINGLE_ERR_POS_LOW0    ) = 0x00000004;
    *(volatile uint32_t *)((&my_mecc)->SINGLE_ERR_POS_HIGH0   ) = 0x00000000;

    MECC_GetSingleErrorInfo(&my_mecc, &singleErrorInfo, 0);

    /* This should be 0. */
    if (singleErrorInfo.singleErrorPosHigh != 0)
    {
        printf("fail");
    }
    else
    {
    	printf("pass");
    }
}

/*!
 * @brief Main function
 */
int main(void)
{
    test_gcc_optimization();
    while (1)
    {
    }
}
